library lnk_trace;

uses
  Windows, kol, CGTShare;

type
//  (+  CGTShare)   IDE
  PPos = ^TPos;
  TPos = record
    X,Y:integer;
    Next:PPos;
    Prev:PPos;
  end;
  TAddProc = function(p:PPos; x,y:integer):PPos;
  TgetPPos = function(p:id_point):PPos;
  
//  
  Point = packed record
    case byte of
    0: (p:integer);
    1: (x,y:smallint);
  end;
  Ppoint=^Tpoint;
  Tpoint = packed record
    dir,len:byte;           // (dir),   (len)
    realPrice:smallint;     //    
    next,trace:Ppoint;      //   (next),   (trace)  
    case byte of            // 
    0: (p:integer);
    1: (x,y:smallint);
  end;
  
  Tstate = (trace0, trace1, trace2, trace3, Body, Pin, Hwire, Vwire);
  Tstates = set of Tstate; //   / 
  
{$INCLUDE constant.inc}


var
//     (   )
  sizeX:integer = $FF;
  sizeY:integer = $FF;
  ofsX,ofsY:integer;
  M:array of array of Tstates;
//       ,   price
  Heap:array of array of Tpoint;
//    (  next)   
  Free:Ppoint;
//    (  next)   
  TraceList:Ppoint;
//   TraceList   price.     dW    
///   TraceList   price = minPrice + dW.
  Hash:array of Ppoint;
  maxW:integer;     // Hash[maxW]      TraceList
  minPrice:integer; //    

// TimerTest
  T0:int64;
  T1,T2,T3,T4:integer;
  
procedure startTimer;
begin
  QueryPerformanceCounter(T0);
end;

function fixTimer:integer;
var Tim,freq:int64;
begin
   QueryPerformanceCounter(Tim);
   QueryPerformanceFrequency(freq);
   freq := freq div 1000000;
   Result := (Tim-T0)div freq;
end;
// end of TimerTest




function ResizeMatrix:boolean;
var i:integer;
begin
  Result := false;
  SetLength(M,sizeX+1); if Length(M)<>sizeX+1 then exit;
  for i:=0 to sizeX do begin
    SetLength(M[i],sizeY+1);
    if Length(M[i])<>sizeY+1 then exit;
  end;
  Result := true;
end;

function NewFreeList:boolean;
var i,j:integer;
begin
  Result := false;
  j := Length(Heap);
  SetLength(Heap,j+1);
  if high(Heap)<>j then exit;
  SetLength(Heap[j],$10000);
  i := high(Heap[j]);
  if i<>$FFFF then exit;
  Heap[j,i].next := nil;
  repeat Heap[j,i-1].next := @Heap[j,i]; dec(i);
  until i=0;
  Free := @Heap[j,0];
  Result := true;
end;

procedure fastNew(var Q:Ppoint);
var p:Ppoint;
begin
  p := Q;
  Q := Free;
  Free := Q.next;
  Q.next := p;
end;

function Idx(X:integer):integer; //    step*N+(2..8)
begin
  Result := (X + 5 - ofsX) div step;
end;

function Idy(X:integer):integer; //    step*N+(2..8)
begin
  Result := (X + 5 - ofsY) div step;
end;

procedure fillBody(x1,y1,x2,y2:integer);
var x,y:Integer;
begin //    Body ( )
  for x := x1 to x2 do
  for y := y1 to y2 do include(M[x, y], Body);
end;

procedure fillRect(x1,y1,x2,y2:integer; bits:Tstates);
var i:Integer;
begin //     bits
  for i := x1 to x2 do begin
    M[i, y1] := M[i, y1] + bits;
    M[i, y2] := M[i, y2] + bits;
  end;
  for i := y1 to y2 do begin
    M[x1, i] := M[x1, i] + bits;
    M[x2, i] := M[x2, i] + bits;
  end;
end;

procedure fillWire(x1,y1,x2,y2:integer);
var x,y:Integer;
begin
  if y1 > y2 then swap(y1,y2);
  if x1 > x2 then swap(x1,x2);
  if x1=x2 then
    for y := y1 to y2 do include(M[x1, y], Vwire);
  if y1=y2 then
    for x := x1 to x2 do include(M[x, y1], Hwire);
end;


function trace(cgt:PCodeGenTools; sdk:id_sdk; pnt:id_point; pos:PPos; add_proc:TAddProc; getPPos:TgetPPos):boolean;
var startX,startY,endX,endY,highX,highY:integer; ///  
  tagD,curD:byte;  ///  
  tagP,curP:Point; ///     
  e:id_element;
  pt:id_point;
  ps,psn:PPos;
  name:pchar;
  Pfind:Ppoint;
  Black:boolean;
  
  function TestSDK:boolean; //   
  var i,j,x,y,w,h, minX,minY,maxX,maxY:integer; realloc:boolean;
  begin with cgt^ do begin
    Result := false;
    minX := short(MAXSHORT); minY := short(MAXSHORT);
    maxX := short(MINSHORT); maxY := short(MINSHORT);
    for i := 0 to sdkGetCount(sdk)-1 do begin
      e := sdkGetElement(sdk, i);
      elGetPos (e, x, y); minX := min(minX, x); minY := min(minY, y);
      elGetSize(e, w, h); maxX := max(maxX, x+w); maxY := max(maxY, y+h);
      for j := 0 to elGetPtCount(e)-1 do begin
        pt := elGetPt(e,j);
        ps := getPPos(pt);
        minX := min(minX, ps.x); minY := min(minY, ps.y);
        maxX := max(maxX, ps.x); maxY := max(maxY, ps.y);
        psn := ps.Next;
        while psn<>nil do begin
          minX := min(minX, psn.x); minY := min(minY, psn.y);
          maxX := max(maxX, psn.x); maxY := max(maxY, psn.y);
          ps := psn;
          psn := ps.Next;
        end;
      end;
    end;
    realloc := false;
    highX := (maxX-minX) div step + 8;
    highY := (maxY-minY) div step + 8;
    if highX>sizeX then begin sizeX := ((highX+$100)and not $FF)-1; realloc:=true end;
    if highY>sizeY then begin sizeY := ((highY+$100)and not $FF)-1; realloc:=true end;
    if realloc then begin
      if (sizeX>=MAXSHORT)or(sizeY>=MAXSHORT)or(not ResizeMatrix) then exit;
      _Debug(pchar('Trace: Matrix reallocated to $'+int2hex(sizeX+1,0)+'x$'+int2hex(sizeY+1,0)),clNavy);
    end;
    ofsX := (minX div step - 3)*step;
    ofsY := (minY div step - 3)*step;
    Result := true;
  end; end;

  function prop2byte(name:pchar; e:id_element):byte;
  var j:integer; p:id_prop;
  begin
    for j := 0 to cgt.elGetPropCount(e)-1 do begin
      p := cgt.elGetProperty(e,j);
      if lstrcmp(cgt.propGetName(p),name)=0 then begin
        Result := cgt.propToByte(p);
        exit;
      end;
    end;
    Result := $FF;
  end;
  
  function pointDirect(p:id_point):byte; //       HubEx|GetDataEx
  const T2D:array[1..4] of byte = (2,0,1,3); //   ->   
  var t,i,angle:byte; e:id_element;
  begin with cgt^ do begin
    t := ptGetType(p);
    e := ptGetParent(p);
    Result := T2D[t];
    name := 'HubEx'; if t in [pt_Var,pt_Data] then name := 'GetDataEx';
    if lstrcmp(name, elGetClassName(e))=0 then begin
    //  , !!!
      angle := prop2byte('Angle',e);
      if t in [pt_Event, pt_Data] then
        Result := (angle + Result) mod 4
      else begin
        i := 3 - ptGetIndex(p);  // (0,1,2) -> (3,2,1)
        if i=angle then i := 0;
        Result := (Result+i+2) mod 4;
      end;
    end;
  end; end;

  procedure InitMatrix; //    
  var i,j,x,y,w,h:integer; Ex:boolean;
  begin with cgt^ do begin
    for i := 0 to highX do FillChar(M[i,0],highY+1,0);
    fillRect(0,0,highX,highY,[trace0,trace1,trace2,trace3]); //     
    for i := 0 to sdkGetCount(sdk)-1 do begin
      e := sdkGetElement(sdk, i);
      elGetPos (e, x, y);
      elGetSize(e, w, h);
      name := elGetClassName(e); Ex := (lstrcmp(name,'HubEx')=0)or(lstrcmp(name,'GetDataEx')=0);
      if Ex then begin //: Ex-    Pin
        if w>h then begin inc(x,6); inc(y,5) end //  GetDataEx  HubEx
        else begin inc(x,4); inc(y,6) end; // ,  ,      
        include(M[Idx(x), Idy(y)], Pin);
      end else if (elGetFlag(e)and IS_BACK)<>0 then begin //  EditMulti[Ex]
        fillRect(Idx(x),Idy(y), Idx(x+w), Idy(y+h),[Body])
      end else if (lstrcmp(name,'InfoTip')=0)and(prop2byte('Transparent',e)=0) then //   
      else //     
        fillBody(Idx(x),Idy(y), Idx(x+w), Idy(y+h));
      for j := 0 to elGetPtCount(e)-1 do begin
        pt := elGetPt(e,j);
        ps := getPPos(pt);
        psn := ps.Next;
        if not Ex then begin //  Ex-   
          include(M[Idx(ps.x), Idy(ps.y)], Pin);
          if ptGetType(pt) in [pt_Var,pt_Data] then exclude(M[Idx(ps.x), Idy(ps.y)], Body);
        end;
        if (pt<>pnt) then begin
          while psn<>nil do begin
            fillWire(Idx(ps.x), Idy(ps.y), Idx(psn.x), Idy(psn.y));
            ps := psn;
            psn := ps.Next;
          end;
        end;
      end;
    end;
  end; end;
  
  function castPrice:integer;
  var uX,uY,wX,wY,wD,D:integer;
  begin
    uX := curP.x - tagP.x;
    uY := curP.y - tagP.y;
    wX := dPrice[0, 0+2*byte(Black)];
    wY := dPrice[0, 1+2*byte(Black)];
    wD := dPrice[0,4];
    //      
    Result := wX*abs(uX) + wY*abs(uY);
    //  (uX,uY)     : uX -  , uY -  
    case tagD of
      1: begin uX := -uX; swap(uX,uY); swap(wX,wY) end;
      2: begin uX := -uX; uY := -uY end;
      3: begin uY := -uY; swap(uX,uY); swap(wX,wY) end;
    end;
    D := (curD-tagD+4)mod 4; //     
    //   -   . ...
    if D=3 then begin uY := -uY; D := 1 end;
    //        "".
    case D of  //    
      0: begin //   
          if uY=0 then inc(Result, (4*wD+2*wY)*byte(uX<0))
          else if abs(uY)=1 then inc(Result, 2*wD+(2*wD+2*wY)*byte(uX<0))
          else inc(Result, 2*wD+2*wD*byte(uX<0))
        end;
      1: begin //  
          if (uX>=0)and(uY>=0) then inc(Result, wD)
          else if uX=0 then inc(Result, 3*wD+2*wX)
          else if uY=0 then inc(Result, 3*wD+2*wY)
          else inc(Result, 3*wD)
        end;
      2: begin //    
          if uY<>0 then inc(Result, 2*wD)
          else inc(Result, 4*wD+2*wY)
        end;
    end;
  end;

  function Search:boolean;
  var D,w,dW,rW,lastPrice:integer;
  begin
    Result := false;
    //       (>0,  - Ex-   )
    curP.x := Idx(endX  -4*dX[curD]);
    curP.y := Idy(endY  -4*dY[curD]);
    //     (>5,  -    Hub-)
    tagP.x := Idx(startX+9*dX[tagD]);
    tagP.y := Idy(startY+9*dY[tagD]);
    //  "" -  (   )      
    w := (tagD and 1)+2*byte(Black);
    lastPrice := dPrice[byte(M[tagP.x,tagP.y])div 16, w] - dPrice[0, w];
    minPrice  := castPrice + lastPrice;
    fastNew(TraceList);
    maxW := 0;
    Hash[0] := TraceList;
    with TraceList^ do begin
      p := curP.p;
      dir := curD;
      realPrice := 0;
      trace := nil;
    end;
    Pfind := TraceList;
    while (Pfind.p<>tagP.p)or((Pfind.dir xor tagD)=2) do begin //  " " -  
      if not(Tstate(Pfind.dir) in M[Pfind.x,Pfind.y]) then begin
        for D := 3 downto 1 do begin
          curD := (Pfind.dir + D + 2) mod 4;
          curP.x := Pfind.x - dX[curD]; //  -   !
          curP.y := Pfind.y - dY[curD]; //  -   !
          if not(Tstate(curD) in M[curP.x,curP.y]) then begin //      
          // rW    realPrice
            w := byte(M[curP.x,curP.y])div 16;
            rW := Pfind.realPrice + dPrice[w, (curD and 1)+2*byte(Black)];
            if D<>2 then //       
              inc(rW, dPrice[byte(M[Pfind.x,Pfind.y])div 16, 4]);
            dW := rW + castPrice - minPrice; //   Hash
            if (curP.p<>tagP.p)or((curD xor tagD)=2) then //  " " -  
              inc(dW, lastPrice)  //  ""
              // ,    :  ""    rW.
            else if curD<>tagD then //  cast-      -  
              inc(dW, dPrice[w,4]-dPrice[0,4]);
            if dW>high(Hash) then begin
              SetLength(Hash,(dW+$400)and not($3FF));
              if dW>high(Hash) then begin
                cgt._Debug('Trace: Hash fault', clRed);
                SetLength(Hash,$400); //  ,  
                exit;
              end else
                cgt._Debug(pchar('Trace: Hash reallocated to $'+int2hex(Length(Hash)*sizeof(Ppoint),0)),clNavy);
            end;
            while maxW<dW do begin inc(maxW); Hash[maxW]:=nil end; //   Hash  
            if Free=nil then begin
              w := Length(Heap);
              if NewFreeList then
                cgt._Debug(pchar('Trace: Heap reallocated to $'+int2hex((w+1)*$10000*sizeof(Tpoint),0)),clNavy)
              else begin
                cgt._Debug('Trace: NEW fault', clRed);
                SetLength(Heap,w); //    ,     TraceList
                exit;
              end;
            end;
            w := dW; while Hash[w]=nil do dec(w); //     (   )
            fastNew(Hash[w].next);    //  =>     
            Hash[dW] := Hash[w].next; //      Hash
            with Hash[dW]^ do begin   //    :
              p := curP.p;            // - 
              dir := curD;            // - 
              realPrice := rW;        // -  
              trace := Pfind;         // -  
            end;
          end;
        end;
        include(M[Pfind.x,Pfind.y], Tstate(Pfind.dir)); //  
      end;
      Pfind := Pfind.next; if Pfind=nil then exit;      // Result = false
    end;
    Result := true;
  end;
  
  procedure DrawTrace;
  var prevX,prevY:integer; drawn:boolean;
  begin
    drawn := false;
    prevX := startX;
    prevY := startY;
    while Pfind<>nil do with Pfind^ do begin
      if dir<>tagD then begin
        if drawn then pos := add_proc(pos, prevX, prevY);
        if (tagD and 1)=0 then prevX := x*step-1-2*byte(Black)+ofsX
        else prevY := y*step-2+byte(Black)+ofsY;
        tagD := dir;
        drawn := true;
      end;
      Pfind := trace;
    end;
    if drawn then begin
      if (tagD and 1)<>0 then prevX := endX
      else prevY := endY;
      pos := add_proc(pos, prevX, prevY);
    end;
  end;

begin
  pos.Next.Prev := pos; //    ???
  startTimer; // TimerTest
  Result := TestSDK;
  if not Result then begin
    cgt._Debug('Trace: Matrix out of memory', clRed);
    sizeX := $FF; sizeY := $FF; ResizeMatrix; //  ,  
    exit;
  end;
//    
  T1 := fixTimer; // TimerTest
  InitMatrix;
  T2 := fixTimer; // TimerTest
//    
  tagD := pointDirect(pnt);
  with getPPos(pnt)^ do begin startX := X; startY := Y end;
//    
  pt := cgt.ptGetLinkPoint(pnt);
  curD := (pointDirect(pt)+2) mod 4;
  with getPPos(pt)^ do begin endX := X; endY := Y end;
  Black := cgt.ptGetType(pnt) in [pt_Work,pt_Event];
//      (endX,endY,endD)  (startX,startY,startD)
  Result := Search;
  T3 := fixTimer; // TimerTest
//   -   ,    "" /   
  if Result then DrawTrace
  else cgt._Debug('Trace: Not traced', clRed);
//  TraceList   Heap,   
  Hash[maxW].next := Free;
  Free := TraceList;
  TraceList := nil;
  T4 := fixTimer; // TimerTest
  cgt._Debug(pchar('TraceTiming: ('+int2str(T1)+', '+int2str(T2)+', '+int2str(T3)+', '+int2str(T4)+') us'), clGray);
end;

exports
  trace;



begin
  SetLength(Hash,$400); //  Hash       $400
  ResizeMatrix;         //      $100x$100
  NewFreeList;          //  Heap       $10000,    
end.
